Package com.mckoi.database.jdbc

## Interface DatabaseInterface

All Known Implementing Classes:
  `AbstractJDBCDatabaseInterface`, `JDBCDatabaseInterface`

    public interface DatabaseInterface

The interface with the Database whether it be remotely via TCP/IP or locally within the current JVM.

Author:
  Tobias Downer

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `dispose()` Called when the connection is disposed.
`void` `disposeResult​(int result_id)` Disposes of a result of a query on the server.
`void` `disposeStreamableObject​(int result_id, long streamable_object_id)` Disposes a streamable object channel with the given identifier.
`QueryResponse` `execQuery​(SQLQuery sql)` Executes the query and returns a QueryResponse object that describes the result of the query.
`ResultPart` `getResultPart​(int result_id, int row_number, int row_count)` Returns a part of a result set.
`StreamableObjectPart` `getStreamableObjectPart​(int result_id, long streamable_object_id, long offset, int len)` Returns a section of a large binary or character stream in a result set.
`boolean` `login​(java.lang.String default_schema, java.lang.String username, java.lang.String password, DatabaseCallBack call_back)` Attempts to log in to the database as the given username with the given password.
`void` `pushStreamableObjectPart​(byte type, long object_id, long object_length, byte[] buf, long offset, int length)` Pushes a part of a streamable object from the client onto the server.

### Method Detail

#### login

    boolean login​(java.lang.String default_schema,
                  java.lang.String username,
                  java.lang.String password,
                  DatabaseCallBack call_back)
           throws java.sql.SQLException

Attempts to log in to the database as the given username with the given password. Only one user may be authenticated per connection. This must be called before the other methods are used.

A DatabaseCallBack implementation must be given here that is notified of all events from the database. Events are only received if the login was successful.

Throws:
  `java.sql.SQLException`

#### pushStreamableObjectPart

    void pushStreamableObjectPart​(byte type,
                                  long object_id,
                                  long object_length,
                                  byte[] buf,
                                  long offset,
                                  int length)
                           throws java.sql.SQLException

Pushes a part of a streamable object from the client onto the server. The server stores the large object for use with a future query. For example, a sequence of with a query with large objects may operate as follows;

     1) Push 100 MB object (id = 104)
     2) execQuery with query that contains a streamable object with id 104

Note that the client may push any part of a streamable object onto the server, however the streamable object must have been completely pushed for the query to execute correctly. For example, an 100 MB byte array may be pushed onto the server in blocks of 64K (in 1,600 separate blocks).

Parameters:
  `type` - the StreamableObject type (1 = byte array, 2 = char array)
  `object_id` - the identifier of the StreamableObject for future queries.
  `object_length` - the total length of the StreamableObject.
  `buf` - the byte[] array representing the block of information being sent.
  `offset` - the offset into of the object of this block.
  `length` - the length of the block being pushed.
Throws:
  `java.sql.SQLException`

#### execQuery

    QueryResponse execQuery​(SQLQuery sql)
                     throws java.sql.SQLException

Executes the query and returns a QueryResponse object that describes the result of the query. The QueryResponse object describes the number of rows, describes the columns, etc. This method will block until the query has completed. The QueryResponse can be used to obtain the 'result id' variable that is used in subsequent queries to the engine to retrieve the actual result of the query.

Throws:
  `java.sql.SQLException`

#### getResultPart

    ResultPart getResultPart​(int result_id,
                             int row_number,
                             int row_count)
                      throws java.sql.SQLException

Returns a part of a result set. The result set part is referenced via the 'result id' found in the QueryResponse. This is used to read parts of the query once it has been found via 'execQuery'.

The returned List object contains the result requested.

If the result contains any StreamableObject objects, then the server allocates a channel to the object via the 'getStreamableObjectPart' and the identifier of the StreamableObject. The channel may only be disposed if the 'disposeStreamableObject' method is called.

Throws:
  `java.sql.SQLException`

#### disposeResult

    void disposeResult​(int result_id)
                throws java.sql.SQLException

Disposes of a result of a query on the server. This frees up server side resources allocated to a query. This should be called when the ResultSet of a query closes. We should try and use this method as soon as possible because it frees locks on tables and allows deleted rows to be reclaimed.

Throws:
  `java.sql.SQLException`

#### getStreamableObjectPart

    StreamableObjectPart getStreamableObjectPart​(int result_id,
                                                 long streamable_object_id,
                                                 long offset,
                                                 int len)
                                          throws java.sql.SQLException

Returns a section of a large binary or character stream in a result set. This is used to stream large values over the connection. For example, if a row contained a multi megabyte object and the client is only interested in the first few characters and the last few characters of the stream. This would require only a few queries to the database and the multi- megabyte object would not need to be downloaded to the client in its entirety.

Throws:
  `java.sql.SQLException`

#### disposeStreamableObject

    void disposeStreamableObject​(int result_id,
                                 long streamable_object_id)
                          throws java.sql.SQLException

Disposes a streamable object channel with the given identifier. This should be called to free any resources on the server associated with the object. It should be called as soon as possible because it frees locks on the tables and allows deleted rows to be reclaimed.

Throws:
  `java.sql.SQLException`

#### dispose

    void dispose()
          throws java.sql.SQLException

Called when the connection is disposed. This will terminate the connection if there is any connection to terminate.

Throws:
  `java.sql.SQLException`